#include "testlib.h"

enum { MAX = 300 };

int
main(int argc, char *argv[])
{
    setName("check the graph topology");
    registerTestlibCmd(argc, argv);

    int N = inf.readInt();
    int K = inf.readInt();
    static int matrix[MAX][MAX];

    if (ans.readInt() == 0) {
        ouf.readEof();
        quitf(_ok, "ok");
    }

    int Nouf = ouf.readInt();
    quitif(!(N * 0.8 - 1 <= Nouf), _wa, "N = %d, Nouf = %d, > 20%%", N, Nouf);
    quitif(!(Nouf <= N * 1.2 + 1), _wa, "N = %d, Nouf = %d, > 20%%", N, Nouf);

    for (int i = 0; i < Nouf; ++i) {
        for (int j = 0; j < Nouf; ++j) {
            matrix[i][j] = ouf.readInt();
        }
    }

    quitif(!ouf.seekEof(), _wa, "outfile has unnecessary data at the end");

    for (int i = 0; i < Nouf; ++i) {
        quitif(!(matrix[i][i] == 0), _wa,
                "diagonal item [%d][%d] is not zero", i, i);
        for (int j = 0; j < Nouf; ++j) {
            quitif(matrix[i][j] != 0 && matrix[i][j] != 1, _wa, 
                    "matrix item [%d][%d] is not 0 or 1 but %d", i, j, matrix[i][j]);
            quitif(matrix[i][j] != matrix[j][i], _wa,
                    "matrix is not symmetric, item [%d][%d] (which equals to %d) "
                    "is not equal to the item [%d][%d] (which equals to %d)",
                    i, j, matrix[i][j], j, i, matrix[j][i]);
        }
    }

    int edg_num = 0;
    for (int i = 0; i < Nouf; ++i) {
        for (int j = 0; j < Nouf; ++j) {
            edg_num += matrix[i][j];
        }
    }
    quitif(!(0.8 * K * Nouf - 1 <= edg_num), _wa, "graph has %d edges, must be more", edg_num);
    quitif(!(edg_num <= 1.2 * K * Nouf + 1), _wa, "graph has %d edges, must be less", edg_num); 

    quit(_ok, "ok");
}
