#include "testlib.h"

#include <vector>

enum { MAX = 100 };

int N, M, field[MAX][MAX];
std::vector<std::pair<int, int>> snake;

bool
in_field(int x, int y)
{
    return 0 <= x && x < N && 0 <= y && y < M;
}

void
read_field(void)
{
    N = inf.readInt(0, MAX, "N");
    inf.readSpace();
    M = inf.readInt(0, MAX, "M");
    inf.readEoln();

    snake.clear();
    size_t count_of_2 = 0;
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < M; ++j) {
            field[i][j] = inf.readInt(0, 3, "field cell");
            if (j != M - 1) {
                inf.readSpace();
            } else{
                inf.readEoln();
            }
            if (field[i][j] == 3) {
                snake.emplace_back(i, j);
            } else if (field[i][j] == 2) {
                ++ count_of_2;
                field[i][j] = 22;
            }
        }
    }

    inf.readEof();

    int last_x = snake[0].first;
    int last_y = snake[0].second;

    while (count_of_2-- > 0) {
        int next_x, next_y;
        int possibilities = 0;

        for (int k = 0; k < 4; ++k) {
            next_x = last_x + (k == 0 ? 1 : k == 1 ? -1 : 0);
            next_y = last_y + (k == 2 ? 1 : k == 3 ? -1 : 0);
            if (in_field(next_x, next_y) && field[next_x][next_y] == 22) {
                ++ possibilities;
                snake.emplace_back(next_x, next_y);
            }
        }
        if (possibilities != 1) {
            quitf(_wa, "Ambigous item of the snake");
        } else {
            field[next_x][next_y] = 2;
        }
    }
}

int
main(int argc, char *argv[])
{
    registerValidation(argc, argv);

    read_field();
#if 0
    int n;
    if ((n = ans.readInt()) == -1) {
        ans.readEof();
    } else {
        ensuref(0 <= n <= 3, "unexpected action %d", n);

        while (!ansf.seekEof()) {
            n = ansf.readInt();
            ensuref(0 <= n <= 3, "unexpected action %d", n);
        }
    }
#endif
}
